# coding: utf-8

"""
    Web Forms API version 1.1

    The Web Forms API facilitates generating semantic HTML forms around everyday contracts.   # noqa: E501

    OpenAPI spec version: 1.1.0
    Contact: devcenter@docusign.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from docusign_webforms.client.configuration import Configuration


class WebFormInstanceMetadata(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'expiration_date_time': 'datetime',
        'created_date_time': 'datetime',
        'created_by': 'WebFormUserInfo',
        'last_modified_date_time': 'str',
        'last_modified_by': 'WebFormUserInfo'
    }

    attribute_map = {
        'expiration_date_time': 'expirationDateTime',
        'created_date_time': 'createdDateTime',
        'created_by': 'createdBy',
        'last_modified_date_time': 'lastModifiedDateTime',
        'last_modified_by': 'lastModifiedBy'
    }

    def __init__(self, _configuration=None, **kwargs):  # noqa: E501
        """WebFormInstanceMetadata - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._expiration_date_time = None
        self._created_date_time = None
        self._created_by = None
        self._last_modified_date_time = None
        self._last_modified_by = None
        self.discriminator = None

        setattr(self, "_{}".format('expiration_date_time'), kwargs.get('expiration_date_time', None))
        setattr(self, "_{}".format('created_date_time'), kwargs.get('created_date_time', None))
        setattr(self, "_{}".format('created_by'), kwargs.get('created_by', None))
        setattr(self, "_{}".format('last_modified_date_time'), kwargs.get('last_modified_date_time', None))
        setattr(self, "_{}".format('last_modified_by'), kwargs.get('last_modified_by', None))

    @property
    def expiration_date_time(self):
        """Gets the expiration_date_time of this WebFormInstanceMetadata.  # noqa: E501


        :return: The expiration_date_time of this WebFormInstanceMetadata.  # noqa: E501
        :rtype: datetime
        """
        return self._expiration_date_time

    @expiration_date_time.setter
    def expiration_date_time(self, expiration_date_time):
        """Sets the expiration_date_time of this WebFormInstanceMetadata.


        :param expiration_date_time: The expiration_date_time of this WebFormInstanceMetadata.  # noqa: E501
        :type: datetime
        """
        if self._configuration.client_side_validation and expiration_date_time is None:
            raise ValueError("Invalid value for `expiration_date_time`, must not be `None`")  # noqa: E501

        self._expiration_date_time = expiration_date_time

    @property
    def created_date_time(self):
        """Gets the created_date_time of this WebFormInstanceMetadata.  # noqa: E501


        :return: The created_date_time of this WebFormInstanceMetadata.  # noqa: E501
        :rtype: datetime
        """
        return self._created_date_time

    @created_date_time.setter
    def created_date_time(self, created_date_time):
        """Sets the created_date_time of this WebFormInstanceMetadata.


        :param created_date_time: The created_date_time of this WebFormInstanceMetadata.  # noqa: E501
        :type: datetime
        """
        if self._configuration.client_side_validation and created_date_time is None:
            raise ValueError("Invalid value for `created_date_time`, must not be `None`")  # noqa: E501

        self._created_date_time = created_date_time

    @property
    def created_by(self):
        """Gets the created_by of this WebFormInstanceMetadata.  # noqa: E501

        The user that created the Web Form Instance  # noqa: E501

        :return: The created_by of this WebFormInstanceMetadata.  # noqa: E501
        :rtype: WebFormUserInfo
        """
        return self._created_by

    @created_by.setter
    def created_by(self, created_by):
        """Sets the created_by of this WebFormInstanceMetadata.

        The user that created the Web Form Instance  # noqa: E501

        :param created_by: The created_by of this WebFormInstanceMetadata.  # noqa: E501
        :type: WebFormUserInfo
        """
        if self._configuration.client_side_validation and created_by is None:
            raise ValueError("Invalid value for `created_by`, must not be `None`")  # noqa: E501

        self._created_by = created_by

    @property
    def last_modified_date_time(self):
        """Gets the last_modified_date_time of this WebFormInstanceMetadata.  # noqa: E501


        :return: The last_modified_date_time of this WebFormInstanceMetadata.  # noqa: E501
        :rtype: str
        """
        return self._last_modified_date_time

    @last_modified_date_time.setter
    def last_modified_date_time(self, last_modified_date_time):
        """Sets the last_modified_date_time of this WebFormInstanceMetadata.


        :param last_modified_date_time: The last_modified_date_time of this WebFormInstanceMetadata.  # noqa: E501
        :type: str
        """

        self._last_modified_date_time = last_modified_date_time

    @property
    def last_modified_by(self):
        """Gets the last_modified_by of this WebFormInstanceMetadata.  # noqa: E501

        The user that last modified the Web Form Instance  # noqa: E501

        :return: The last_modified_by of this WebFormInstanceMetadata.  # noqa: E501
        :rtype: WebFormUserInfo
        """
        return self._last_modified_by

    @last_modified_by.setter
    def last_modified_by(self, last_modified_by):
        """Sets the last_modified_by of this WebFormInstanceMetadata.

        The user that last modified the Web Form Instance  # noqa: E501

        :param last_modified_by: The last_modified_by of this WebFormInstanceMetadata.  # noqa: E501
        :type: WebFormUserInfo
        """

        self._last_modified_by = last_modified_by

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(WebFormInstanceMetadata, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, WebFormInstanceMetadata):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, WebFormInstanceMetadata):
            return True

        return self.to_dict() != other.to_dict()
